package com.jdc.jdcproject.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import lombok.Data;

/**
 * 机组表;
 * @TableName fangpaishui_unit
 */
@TableName(value ="fangpaishui_unit")
@Data
public class FangpaishuiUnit implements Serializable {
    /**
     * 主键，唯一标识机组
     */
    @TableId(value = "UnitID")
    private Integer unitID;

    /**
     * 外键，关联所属设备
     */
    @TableField(value = "EquipmentId")
    private Integer equipmentId;

    /**
     * 机组编号（如“4#多级泵(200)”）
     */
    @TableField(value = "UnitCode")
    private String unitCode;

    /**
     * 额定排水量（固定属性）
     */
    @TableField(value = "RatedCapacity")
    private Integer ratedCapacity;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

    @Override
    public boolean equals(Object that) {
        if (this == that) {
            return true;
        }
        if (that == null) {
            return false;
        }
        if (getClass() != that.getClass()) {
            return false;
        }
        FangpaishuiUnit other = (FangpaishuiUnit) that;
        return (this.getUnitID() == null ? other.getUnitID() == null : this.getUnitID().equals(other.getUnitID()))
            && (this.getEquipmentId() == null ? other.getEquipmentId() == null : this.getEquipmentId().equals(other.getEquipmentId()))
            && (this.getUnitCode() == null ? other.getUnitCode() == null : this.getUnitCode().equals(other.getUnitCode()))
            && (this.getRatedCapacity() == null ? other.getRatedCapacity() == null : this.getRatedCapacity().equals(other.getRatedCapacity()));
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((getUnitID() == null) ? 0 : getUnitID().hashCode());
        result = prime * result + ((getEquipmentId() == null) ? 0 : getEquipmentId().hashCode());
        result = prime * result + ((getUnitCode() == null) ? 0 : getUnitCode().hashCode());
        result = prime * result + ((getRatedCapacity() == null) ? 0 : getRatedCapacity().hashCode());
        return result;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", unitID=").append(unitID);
        sb.append(", equipmentId=").append(equipmentId);
        sb.append(", unitCode=").append(unitCode);
        sb.append(", ratedCapacity=").append(ratedCapacity);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}