package com.jdc.jdcproject.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.time.LocalDate;
import lombok.Data;

/**
 * 处理水量记录表;
 * @TableName fangpaishui_watertreatmentrecord
 */
@TableName(value ="fangpaishui_watertreatmentrecord")
@Data
public class FangpaishuiWatertreatmentrecord implements Serializable {
    /**
     * 主键，唯一标识记录
     */
    @TableId(value = "TreatmentID", type = IdType.AUTO)
    private Integer treatmentID;

    /**
     * 处理水量（单位：立方米）
     */
    @TableField(value = "WaterVolume")
    private Integer waterVolume;

    /**
     * 拉泥车数（单位：车）
     */
    @TableField(value = "TruckCount")
    private Integer truckCount;

    /**
     * 月份（格式：YYYY-MM）
     */
    @TableField(value = "MonthValue")
    private LocalDate monthValue;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

    @Override
    public boolean equals(Object that) {
        if (this == that) {
            return true;
        }
        if (that == null) {
            return false;
        }
        if (getClass() != that.getClass()) {
            return false;
        }
        FangpaishuiWatertreatmentrecord other = (FangpaishuiWatertreatmentrecord) that;
        return (this.getTreatmentID() == null ? other.getTreatmentID() == null : this.getTreatmentID().equals(other.getTreatmentID()))
            && (this.getWaterVolume() == null ? other.getWaterVolume() == null : this.getWaterVolume().equals(other.getWaterVolume()))
            && (this.getTruckCount() == null ? other.getTruckCount() == null : this.getTruckCount().equals(other.getTruckCount()))
            && (this.getMonthValue() == null ? other.getMonthValue() == null : this.getMonthValue().equals(other.getMonthValue()));
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((getTreatmentID() == null) ? 0 : getTreatmentID().hashCode());
        result = prime * result + ((getWaterVolume() == null) ? 0 : getWaterVolume().hashCode());
        result = prime * result + ((getTruckCount() == null) ? 0 : getTruckCount().hashCode());
        result = prime * result + ((getMonthValue() == null) ? 0 : getMonthValue().hashCode());
        return result;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", treatmentID=").append(treatmentID);
        sb.append(", waterVolume=").append(waterVolume);
        sb.append(", truckCount=").append(truckCount);
        sb.append(", monthValue=").append(monthValue);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}